#````````````````````````````
#  fR[h
#````````````````````````````
sub decode {
	my ($buffer, $pairs, $value, @pairs);

	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else {
		$buffer = $ENV{'QUERY_STRING'};
	}

	@pairs = split(/&/, $buffer);

	foreach (@pairs) {
		($pairs, $value) = split(/=/, $_);

		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/&/&amp;/g;
		$value =~ s/"/&quot;/g;
		$value =~ s/'/&#39;/g;
		$value =~ s/\//&#47;/g;
		$value =~ s/\./&#8901;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\t/  /g;
		$value =~ s/\0//g;

		# ^O
		if (!$notag) {
			my $tag = join ('|', @oktag);
			$value =~ s/&lt;(\/?($tag).*?)&gt;/<$1>/ig;
		}

		# nCp[N
		$value =~ s/(http:\/\/[a-zA-Z0-9\.\/\-+#_!?~&%=^\@:;,'*\(\)]+)/<a href="$1">$1<\/a>/g;

		&jcode'convert(*value,'sjis');
		$FORM{$pairs} = $value;
	}
}

sub decode2 {
	$_[0] =~ tr/a-fA-F0-9/fedcbaFEDCBA9876543210/;
	$_[0] =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$_[0] =~ tr/+/ /;
	return $_[0];
}

#````````````````````````````
#  Xe[^X
#````````````````````````````
sub stc {
	my ($val, $st) = @_;
	if ($st =~ s/(.+?)(\d+)//) {
		if ($1 eq '+') { $val += $2; }
		elsif ($1 eq '-') { $val -= $2; }
	}
	return $val;
}

#````````````````````````````
#  zXgl
#````````````````````````````
sub get_host {
	my ($addr, $host) = ($ENV{'REMOTE_ADDR'}, $ENV{'REMOTE_HOST'});

	if ($host eq $addr || !$host) {
		$host = gethostbyaddr(pack("C4", split(/\./,$addr)), 2) || $addr;
	}

	return $ENV{'HTTP_USER_AGENT'};
	#return $host;
}

#==============================================
#  ANZX`FbN
#==============================================
sub access_check {
	#if ($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^$refurl/) || $ENV{'REQUEST_METHOD'} ne 'POST') {
	#if ($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^(http:\/\/$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'})/)) {
	if ($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^$refurl/)) {
		&error("sȃANZXłB");
	}
}

#````````````````````````````
#  ANZX
#````````````````````````````
sub deny {

	my $denyflg;
	for (my $i = 0; $i < ((@deny)+(@deny2)); $i++) {
		# IPzXg
		if ($deny[$i]) {
			$deny[$i] =~ s/\./\\./g; $deny[$i] =~ s/\*/\.\*/g;
			if ($host =~ /$deny[$i]/i) { $denyflg = 1; last; }
		}

		# Cookie
		if ($deny2[$i]) {
			if ($COOKIE{'name'} eq $deny2[$i]) { $denyflg = 1; last; }
		}
	}

	if ($denyflg) {
		&error($denyms);
	}
}

#==============================================
#  NbL[o
#==============================================
sub set_cookie {
	my ($name, $color, $reload, $viewlog) = @_;
	my (@mons, @week, $date, $cook);
	my ($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime(time + 365*24*60*60);

	@mons = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	$date = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",
						$week[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec);

	print "Set-Cookie: MBC=name\:$name\,color\:$color\,reload\:$reload\,viewlog\:$viewlog; expires=$date\n";
}

#==============================================
#  NbL[ǂݏo
#==============================================
sub get_cookie {
	my ($name, $value, @pairs, %DUMMY, %COOKIE);

	@pairs = split(/\;/, $ENV{'HTTP_COOKIE'});

	foreach (@pairs) {
		($name, $value) = split(/\=/, $_);
		$name =~ s/ //g;
		$DUMMY{$name} = $value;
	}

	@pairs = split(/\,/, $DUMMY{'MBC'});

	foreach (@pairs) {
		($name, $value) = split(/\:/, $_);
		$COOKIE{$name} = $value;
	}

	return %COOKIE;
}

#````````````````````````````
#  t@Cǂݍ
#````````````````````````````
sub file_read {
	my ($file) = @_;

	open(FILE, "$file") || &error("t@C\"$file\"J܂łB");
		my @line = <FILE>;
	close(FILE);

	chomp (@line);

	return @line;
}

#````````````````````````````
#  t@C
#````````````````````````````
sub file_write {
	my ($file, @data) = @_;

	open(FILE, ">$file") || &error("t@C\"$file\"J܂łB");
		flock (FILE, 2) if ($lock == 1); # bN
		foreach (@data) {
			print FILE "$_\n";
		}
		seek (FILE, 0, 0) if ($lock == 1); # bN
	close(FILE);
}

#````````````````````````````
#  tl
#````````````````````````````
sub get_days {
	my ($sec, $min, $hour, $dy, $mon, $year, $wday, $yday, $isdst) = gmtime(time+60*60*9);
	my @week = ('','','','','','','y');

	$days = sprintf("%04d/%01d/%01d\(%s\) %02d:%02d", $year+1900, $mon+1, $dy, $week[$wday], $hour, $min);

	return $days;
}

#````````````````````````````
#  OĂяo
#````````````````````````````
sub mem {
	# t@Cǂݍ
	my @mem = &file_read($member);

	my $i = 0;
	my $tmp;
	if ($memnam) {
		foreach (@mem) {
			chomp;
			my ($type, $mtime, $mhost, $mname, $mcol) = split (/\t/, $_);

			$tmp .= " <font color=\"$fcolor[$mcol]\">$mname</font>";

			$i++ if ($type);
		}

		$tmp &&= "<br>$tmp";
	}

	# o
	print "Content-type: text/javascript\n\n";
	print "document.write('<small>`bgQ <b>$i</b>l$tmp</small>');";
}

#````````````````````````````
#  wb_[
#````````````````````````````
sub header {
	print "Content-type: text/html\n\n";

	print qq(
	<html><head>
	<meta http-equiv="Content-type" content="text/html; charset=shift_jis">
	);

	if ($_[1]) {
		print qq(<meta http-equiv="refresh" content="$_[1];URL=$script?mode=reload&name=$FORM{'name'}&no=$_[0]&reload=&viewlog=">);
	} elsif ($FORM{'reload'} ne '' && $FORM{'reload'} ne 'none') {
		print qq(<meta http-equiv="refresh" content="$FORM{'reload'};URL=$script?mode=log&in=2&name=$FORM{'name'}&reload=$FORM{'reload'}&viewlog=$FORM{'viewlog'}">);
	}

	print qq(
	<title>$cgititle</title>
	<link rel="stylesheet" type="text/css" href="$style">
	);
}

#````````````````````````````
#  쌠
#````````````````````````````
sub copy {
	print <<"_HTML_";
<div align="right">
<font size="1">
<a href="http://mcgi.jpn.ch/" target="_blank">܂₩`bg Ver$version</a>
</font>
</div>
_HTML_
}

#````````````````````````````
#  bN
#````````````````````````````
sub lock {
	# 3ȏÂbN͉
	if (-e $lockdir) {
		my $mtime = (stat($lockdir))[9];
		if ($mtime < time - 60*3) { &unlock; }
	}

	my $retry = 5;

	while (!mkdir($lockdir, 0755)) {
		if (--$retry <= 0) {
			&error('rW[ԂłB΂炭҂ĂēxMĂB');
		}
		sleep(1);
	}

	$lockflg = 1;
}

#````````````````````````````
#  bN
#````````````````````````````
sub unlock {
	rmdir($lockdir);
	$lockflg = 0;
}

#````````````````````````````
#  G[
#````````````````````````````
sub error {
	&unlock if ($lockflg);

	&header('error');

	print qq(
	</head>
	<body class="ftop">
	<p><table><tr><td><font color="#CC3333">G[</font><br>
	);

	print qq(<font color="#CC3333">&gt;&nbsp;</font>$_[0]<br>);

	print qq(</tr></td></table></p>);
	if ($bflag) {
		print qq(<a href="JavaScript:window.close();"></a>);
	} else {
		print qq(<a href="JavaScript:history.back()">߂</a>);
	}

	print qq(</body></html>);

	exit;
}
1;